      program aewpjoc1
C Combine all results for Dst=<100 nT in common matrix
C
C.......................................................Mar. 2013
C Select wnjoc & wpjoc for 24 hrs prior Dstmin, and 48 hrs after Dstmin

C.......................................................Mar. 2009
C 
C Input DSTPEAK (min of Dst): yr,mn,dy,UTmin; 
C
C
C Input dststorm2.txt = 296 storms for 1999-2012	(both moderate Dst<-50 and intense Dst<-100 nT)
C Output of results in separate files 1)for Dst=<-100, 2) -50>Dst>-100 
C Probability of w-storms & W+storms counts
C
C
C 1) Select periods of Dst storms (hour by hour UT)
C
C 2) Sort and analyse hourly occurrence from W-index maps 
C    Count W=-3 & W=-4	
C    Count W=+3 & W=+4
C 
C
c monthly-hourly Wnoc, Wpoc collected for UT: 0, 1, ...,23 hrs
c from JPL TEC maps
c
	DIMENSION im(12),dst(0:23),iwnoc(0:23),iwpoc(0:23)
	+,dsdat(310),iresp(73,79),iresn(73,79),idst(73,79)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64 infile1,infile2,outfile1,outfile2,infileb2
	+,infildst
      CHARACTER*2 AYR,AMN,AMN1,AMN2,CDY,CMN
	CHARACTER*2 ADY,AUT,DYR,DMN,DDY,XUT
	+,wyr(310),wmn(310),wdy(310),wut(310)
		CHARACTER*128 title
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	integer*2 jut,jyr,jmn,jdy,jdy1,jdy2
	+,iut1,iut2,jut1,jut2,jmn1,jmn2
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

      outfile1='dstwjoc1.txt' ! for Dststorm2.txt input Dst<=-100
	outfile2='dstwjoc2.txt' ! for Dststorm2.txt input -100<Dst<=-50
C
	OPEN(112,FILE=OUTFILE1,ACCESS='APPEND')
	OPEN(113,FILE=OUTFILE2,ACCESS='APPEND')

C start = Enter of Dst storms Catalog

C nn  Start UT   Peak  UT DOY  Dav Dst-min EndDay UT Hrs Dst-mean 
C-----------------------------------------------------------------
C001 990113 17  990113 23  13  -39. -112.  990115 11  43  -66.
C002 990123 17  990123 22  23  -26.  -52.  990124  1   9  -41.

	infildst='dststorm2.txt'
  801	format(A64)
  802	format(15X,3(A2),1X,I2,11X,F5.0)
	OPEN(10,FILE=infildst,ACTION='READ')
	jend=0
	DO j=1,310
	read(10,802,end=800) wyr(j),wmn(j),wdy(j),iut,dsdat(j) ! Peak of Dst storm
	jend=jend+1
c-	 write(*,802) wyr(j),wmn(j),wdy(j),iut,dsdat(j)
	call blet2(iut,AUT)
	wut(j)=aut
	enddo
  800	close (unit=10)
  305	format(2(1X,I4),1X,F6.0)
C ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C Cycle on Dst storms
      nst1=0	
	nst2=0	
  805	DO 870 nn=1,jend
C
	adst=dsdat(nn)
C 
	jj=0 ! count successive UT records
	if (adst.gt.-100.) goto 870  ! Only intense Dst storms ++++++++++++
      if (adst.le.-100.) then
	nst1=nst1+1
	write(*,305) nst1,nn,adst
	write(112,305) nst1,nn,adst
	else
	nst2=nst2+1
	write(*,305) nst2,nn,adst
crem	write(113,305) nst2,nn,adst
	endif

C
	ayr=wyr(nn)
 	read(ayr,*) ryr
	jyr=int(ryr)
	cmn=wmn(nn)
 	read(cmn,*) rmn
	jmn=int(rmn)
	cdy=wdy(nn)
 	read(cdy,*) rdy
	jdy=int(rdy)
	lda=ndoy(jyr,jmn,jdy)
	lda1=lda-1
	if (lda1.le.0) then
	lda1=lda
	endif
	lda2=lda+2
	call submmdd(lda1,jyr,jmn1,jdy1) 
	call submmdd(lda2,jyr,jmn2,jdy2) 
	call blet2(jmn1,AMN1)
	call blet2(jmn2,AMN2)
	xut=wut(nn)
 	read(xut,*) rut
	jut=int(rut)
	jut1=jut
	jut2=jut

C
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
  	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
  196	format(A12)
  195	format(A128)
C
  809	continue
C Open Dst file to select Dst
  	infileb2='d:/Apkp/dst20YR'		 !

	infileb2(14:15)=AYR
	if (AYR.eq.'99') then
	infileb2(12:13)='19'
	                 else
	infileb2(12:13)='20'
	endif
      OPEN(34,FILE=infileb2,ACTION='READ')
	do id=1,lda1-1
	READ(34, 197, END=855) DYR,DMN,DDY,(DST(k),k=0,23) ! 
	enddo
  197 format(3X,2A2,1X,A2,10X,24(F4.0))
  855 CONTINUE
c	READ(34, 196, END=???) DST ! 
      infile1='pjtocYR.txt'	 !W+ storm occur.
	infile1(6:7)=ayr
	infile2=infile1			 !W- storm occur.
	infile2(1:1)='n'
C
  194 format(3A2,24(1X,I4))
	OPEN(110,FILE=INFILE1,ACTION='READ')
	OPEN(111,FILE=INFILE2,ACTION='READ')
	READ(110, 195) title  !Extra line
	READ(111, 195) title  !Extra line
	do iw=1,lda1-1
	READ(110, 194, END=855) DYR,DMN,DDY,(iwpoc(k),k=0,23) ! 
	READ(111, 194, END=855) DYR,DMN,DDY,(iwnoc(k),k=0,23) ! 
	enddo
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C Day-to-day cycle
  807	lda=lda1-1	! pre-start value
	jdy=jdy1-1	! pre-start value
  810	jdy=jdy+1
	lda=lda+1
	if (lda.gt.lda2) GOTO  851 ! end of event
	call submmdd(lda,jyr,jmn,jdy)
	call blet2(jmn,AMN)
	call blet2(jdy,ADY)

C read Dst for day lda:
  301	READ(34, 197,err=870,end=870) DYR,DMN,DDY,(DST(k),k=0,23) ! Dst hourly
	if ((dmn.eq.amn).and.(ddy.eq.ady)) then
	goto 302 
	else
	goto 301
	endif
  302	READ(110, 194,err=870,end=870) DYR,DMN,DDY,(iwpoc(k),k=0,23) ! Wpoc hourly
	if ((dmn.eq.amn).and.(ddy.eq.ady)) then
	goto 303 
	else
	goto 302
	endif
  303	READ(111, 194,err=870,end=870) DYR,DMN,DDY,(iwnoc(k),k=0,23) ! Wnoc hourly
	if ((dmn.eq.amn).and.(ddy.eq.ady)) then
	goto 304 
	else
	goto 303
	endif

C Start cycle on ut
  304	if (lda.eq.lda1) then
	iut1=jut1
	iut2=23
	goto 833
	endif
	if ((lda.gt.lda1).and.(lda.lt.lda2)) then
	iut1=0
	iut2=23
	goto 833
	endif
	     if (lda.eq.lda2) then
	iut1=0
	iut2=jut2
	           endif
C
  833	DO 850 JUT=IUT1,IUT2         ! ------------------------
C>>>
CREM!!!		if (nace.eq.0) goto 850 ! no Bz for given day, UT
C>>>
C Zero counts for each UT
C
	call blet2(jut,AUT)
	jj=jj+1
C
C+++++++++++++++++++++++++++++
	 iocp=iwpoc(jut)
	iocn=iwnoc(jut)
	dstut=dst(jut)
	write(*,272) AYR,AMN,ady,aut,iocp,iocn,dstut
	if (adst.le.-100.) then
	iresp(jj,nst1)=iocp
	iresn(jj,nst1)=iocn
	idst(jj,nst1)=int(dstut)
crem	write(112,272) AYR,AMN,ady,aut,iocp,iocn,dstut
	 else
	write(113,272) AYR,AMN,ady,aut,iocp,iocn,dstut
	 endif
 850	CONTINUE             ! END CYCLE on UT =============================

 849	 GOTO 810 ! next day of event
C 
851	 CONTINUE	   ! END of CYCLE ON EVENT
	close(unit=34)
	close(unit=110)
	close(unit=111)
  870	continue			 ! next event
270   format(72(1X,I4))  
crem 271   format(1X,3A2,1X,A2,4(1X,F7.3),4(1X,F6.0))
272   format(1X,3A2,1X,A2,2(1X,I4),1X,F6.0)
   71	format(A64)
   82	format(2A2,I2,24(1X,I4))
	write(112,*) ' wpos'
      do kk=1,73
	write(*,273) (iresp(kk,k),k=1,79)
	write(112,273) (iresp(kk,k),k=1,79)
	enddo
	write(112,*) ' wneg'
      do kk=1,73
	write(*,273) (iresn(kk,k), k=1,79)
	write(112,273) (iresn(kk,k),k=1,79)
	enddo
	write(112,*) ' Dst'
      do kk=1,73
	write(*,273) (idst(kk,k),k=1,79)
	write(112,273) (idst(kk,k),k=1,79)
	enddo
  273   format(79(1X,I4))
		CLOSE(unit=112)
	CLOSE(unit=113)
	goto 900                ! Next input file
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 continue
      pause ' '
      STOP
      END


C ====================================================================
