      program sscwajoc1
C Combine all results for SSC events in common matrix
C
C.......................................................Jan. 2015
C Select wwYYxx.txt occurrence for 24 hrs prior SSC, and 48 hrs after SSC
C xx=<ln>,<ls>,<lg> (W=-3,-4 for North,South;Global)
C xx=<un>,<us>,<ug> (W=+3,+4 for North,South;;Global)
C 
C Input SSC : yr,mn,dy,UT; 
C (1) 455 SSC = total for 1999-2015         <ssc1.dat>
C (2) 224 SSS = with IMF @ SW precursors    <nsscbz.txt>
C
C Output of results in separate files 1)for Dst=<-100, 2) -50>Dst>-100 
C Probability of w-storms & W+storms counts
C
C
C
C 2) Sort and analyse hourly occurrence from W-index maps 
C    Count W=-3 & W=-4	
C    Count W=+3 & W=+4
C 
C
c monthly-hourly Wnoc, Wpoc collected for UT: 0, 1, ...,23 hrs
c from JPL TEC maps
c
	DIMENSION im(12),dst(0:23),iwnoc(0:23),iwpoc(0:23)
c	+,iresp(460,79),iresn(460,79),idst(460,79)
c	+,ibesp(460,79),ibesn(460,79),ibdst(460,79)
	+,iresp(79),iresn(79),idst(79)
	+,ibesp(79),ibesn(79),ibdst(79)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ,text 
	CHARACTER*64 infile1,infile2,outfile1p,outfile1n,infileb2
	+,infilssc,infilsbz,txt,outfile1d,outfile2p,outfile2n,outfile2d
      CHARACTER*2 AYR,AMN,AMN1,AMN2,CDY,CMN,CYR,CUT
	CHARACTER*2 ADY,AUT,DYR,DMN,DDY,XUT,XX,YY
	+,wyr(500),wmn(500),wdy(500),wut(500)
	+,byr(500),bmn(500),bdy(500),but(500)
		
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	integer*2 jut,jyr,jmn,jdy,jdy1,jdy2
	+,iut1,iut2,jut1,jut2,jmn1,jmn2
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

      outfile1p='sscwjoc1p.txt' ! for W+ rest SSC1.dat output 
	outfile1n='sscwjoc1n.txt' ! for W- rest SSC1.dat output 
	outfile1d='sscwjoc1d.txt' ! for Dst rest SSC1.dat output 
	outfile2p='sscbzoc2p.txt' ! for W+ nsscbz.txt input SSC with IMF&SW precursors
	outfile2n='sscbzoc2n.txt' ! for W+ nsscbz.txt input SSC with IMF&SW precursors
	outfile2d='sscbzoc2d.txt' ! for W+ nsscbz.txt input SSC with IMF&SW precursors
C
	OPEN(12,FILE=OUTFILE1p,ACCESS='APPEND')
	OPEN(13,FILE=OUTFILE1n,ACCESS='APPEND')
	OPEN(14,FILE=OUTFILE1d,ACCESS='APPEND')
	OPEN(15,FILE=OUTFILE2p,ACCESS='APPEND')
	OPEN(16,FILE=OUTFILE2n,ACCESS='APPEND')
	OPEN(17,FILE=OUTFILE2d,ACCESS='APPEND')
C start 
CREM	XX='un'	   !TEMP
CREM	YY='ln'
       	XX='us'	   !TEMP
	YY='ls'

	if (XX.eq.'un') then
	text='North'
	else
	text='South'
	endif
	write(*,804) text
	write(12,804) text
	write(13,804) text
	write(14,804) text
	write(15,804) text
	write(16,804) text
	write(17,804) text

CYEAR MN DD UT 
C-----------------------------------------------------------------
C1999 01 06 1420
	do i=1,500
	wyr(i)='00'
	wmn(i)='00'
	wdy(i)='00'
	wut(i)='00'
	byr(i)='00'
	bmn(i)='00'
	bdy(i)='00'
	but(i)='00'
	enddo

C = Enter of SSC storms Catalog
	infilssc='ssc1.dat'
  801	format(A64)
  802	format(2X,A2,3(1X,A2))
  803	format(5X,3A2,1X,A2)
  804	format(1X,A5)
	OPEN(10,FILE=infilssc,ACTION='READ')
	jend=0
	DO j=1,500
	read(10,802,end=800) wyr(j),wmn(j),wdy(j),wut(j) ! SSC storm
	jend=jend+1
c-	 write(*,802) wyr(j),wmn(j),wdy(j),wut(j)
	enddo
  800	close (unit=10)

C     YYMMDD UTMM   dB(3h)@UT   dB/dt @UT  Bzmin @ UT  dVsw/dt@UT
C   1 990113 1004    6.00  10    5.40  10   -9.40  11   36.00  10

	infilsbz='nsscbz.txt'
	OPEN(10,FILE=infilsbz,ACTION='READ')
	read(10,801) txt ! extra line
	jbend=0
	do 22 j=1,jend
	AYR=wyr(j)
	AMN=wmn(j)
	ADY=wdy(j)
	AUT=wut(j)
	read(10,803,end=74) cyr,cmn,cdy,cut ! SSC(Bz) storm
	if(cut(1:1).eq.' ') cut(1:1)='0'
	if(cut(2:2).eq.' ') cut(2:2)='0'
	if((cyr.eq.AYR).and.(cmn.eq.AMN).and.(cdy.eq.ADY)
	+.and.(cut.eq.AUT)) then
	jbend=jbend+1
	byr(j)=cyr
	bmn(j)=cmn
	bdy(j)=cdy
	but(j)=cut
	goto 22
	                      else
	backspace(10)
	goto 22
	                     endif
   22	continue
  74  close(unit=10)					 					   

  305	format(2(1X,I4))
C ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C Cycle on Dst storms
      nst1=0	
	nst2=0	
  805	DO 870 nn=1,jend
C
	do k=1,79
    	iresp(k)=0
	iresn(k)=0
	idst(k)=0
	ibesp(k)=0
	ibesn(k)=0
	ibdst(k)=0
	enddo
C 
      iflag=0
	jj=0 ! count successive UT records
	nst1=nst1+1
	if ((wyr(nn).eq.byr(nn)).and.(wmn(nn).eq.bmn(nn)).and.
	+(wdy(nn).eq.bdy(nn)).and.(wut(nn).eq.but(nn))) nst2=nst2+1
C
	write(*,305) nst1,nst2
C-	write(12,305) nst1,nst2
C-	write(13,305) nst1,nst2

C
	ayr=wyr(nn)
 	read(ayr,*) ryr
	jyr=int(ryr)
	cmn=wmn(nn)
 	read(cmn,*) rmn
	jmn=int(rmn)
	cdy=wdy(nn)
 	read(cdy,*) rdy
	jdy=int(rdy)
	lda=ndoy(jyr,jmn,jdy)
	lda1=lda-1
	if (lda1.le.0) then
	lda1=lda
	endif
	lda2=lda+2
	call submmdd(lda1,jyr,jmn1,jdy1) 
	call submmdd(lda2,jyr,jmn2,jdy2) 
	call blet2(jmn1,AMN1)
	call blet2(jmn2,AMN2)
	xut=wut(nn)
 	read(xut,*) rut
	jut=int(rut)
	jut1=jut
	jut2=jut

C
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
  	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
  196	format(A12)
  195	format(A128)
C
  809	continue
C Open Dst file to select Dst
  	infileb2='d:/Apkp/dst/dst20YR'		 !

	infileb2(18:19)=AYR
	if (AYR.eq.'99') then
	infileb2(16:17)='19'
	                 else
	infileb2(16:17)='20'
	endif
      OPEN(34,FILE=infileb2,ACTION='READ')
	do id=1,lda1-1
	READ(34, 197, END=855) DYR,DMN,DDY,(DST(k),k=0,23) ! 
	enddo
  197 format(3X,2A2,1X,A2,10X,24(F4.0))
  855 CONTINUE
c	READ(34, 196, END=???) DST ! 
C      infile1='pjtocYR.txt'	 !W+ storm occur.
      infile1='wwYRxx.txt'	 !W+ storm occur.
	infile1(3:4)=ayr
	infile1(5:6)=XX
	infile2=infile1			 !W- storm occur.
	infile2(5:6)=YY 		 !W- 
C
  194 format(3A2,24(1X,I4))
	OPEN(110,FILE=INFILE1,ACTION='READ')
	OPEN(111,FILE=INFILE2,ACTION='READ')
C-	READ(110, 195) title  !Extra line
C-	READ(111, 195) title  !Extra line
	do iw=1,lda1-1
	READ(110, 194, END=855) DYR,DMN,DDY,(iwpoc(k),k=0,23) ! 
	READ(111, 194, END=855) DYR,DMN,DDY,(iwnoc(k),k=0,23) ! 
	enddo
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C Day-to-day cycle
  807	lda=lda1-1	! pre-start value
	jdy=jdy1-1	! pre-start value
  810	jdy=jdy+1
	lda=lda+1
	if (lda.gt.lda2) GOTO  851 ! end of event
	call submmdd(lda,jyr,jmn,jdy)
	call blet2(jmn,AMN)
	call blet2(jdy,ADY)

C read Dst for day lda:
  301	READ(34, 197,err=870,end=853) DYR,DMN,DDY,(DST(k),k=0,23) ! Dst hourly
	if ((dmn.eq.amn).and.(ddy.eq.ady)) then
	goto 302 
	else
	goto 301
	endif
  302	READ(110, 194,err=870,end=853) DYR,DMN,DDY,(iwpoc(k),k=0,23) ! Wpoc hourly
	if ((dmn.eq.amn).and.(ddy.eq.ady)) then
	goto 303 
	else
	goto 302
	endif
  303	READ(111, 194,err=870,end=853) DYR,DMN,DDY,(iwnoc(k),k=0,23) ! Wnoc hourly
	if ((dmn.eq.amn).and.(ddy.eq.ady)) then
	goto 304 
	else
	goto 303
	endif

C Start cycle on ut
  304	if (lda.eq.lda1) then
	iut1=jut1
	iut2=23
	goto 833
	endif
	if ((lda.gt.lda1).and.(lda.lt.lda2)) then
	iut1=0
	iut2=23
	goto 833
	endif
	     if (lda.eq.lda2) then
	iut1=0
	iut2=jut2
	           endif
C
  833	DO 850 JUT=IUT1,IUT2         ! ------------------------
C>>>
CREM!!!		if (nace.eq.0) goto 850 ! no Bz for given day, UT
C>>>
C Zero counts for each UT
C
	call blet2(jut,AUT)
	jj=jj+1
C
C+++++++++++++++++++++++++++++
	 iocp=iwpoc(jut)
	iocn=iwnoc(jut)
	dstut=dst(jut)
	write(*,272) AYR,AMN,ady,aut,iocp,iocn,dstut
	if ((wyr(nn).eq.byr(nn)).and.(wmn(nn).eq.bmn(nn)).and.
	+(wdy(nn).eq.bdy(nn)).and.(wut(nn).eq.but(nn))) then
	ibesp(jj)=iocp
	ibesn(jj)=iocn
	ibdst(jj)=int(dstut)
	iflag=1
crem	write(112,272) AYR,AMN,ady,aut,iocp,iocn,dstut
	 else
	iresp(jj)=iocp
	iresn(jj)=iocn
	idst(jj)=int(dstut)
	iflag=2
crem	write(13,272) AYR,AMN,ady,aut,iocp,iocn,dstut
	 endif
 850	CONTINUE             ! END CYCLE on UT =============================

 849	 GOTO 810 ! next day of event
C 

851	 CONTINUE	   ! END of CYCLE ON EVENT
853	close(unit=34)
	close(unit=110)
	close(unit=111)
	if (iflag.eq.2) then
	write(*,273) AYR,AMN,ADY,AUT,(iresp(k),k=19,72)
	write(12,273) AYR,AMN,ADY,AUT,(iresp(k),k=19,72)
	write(*,273) AYR,AMN,ADY,AUT,(iresn(k),k=19,72)
	write(13,273) AYR,AMN,ADY,AUT,(iresn(k),k=19,72)
	write(*,273) AYR,AMN,ADY,AUT,(idst(k),k=19,72)
	write(14,273) AYR,AMN,ADY,AUT,(idst(k),k=19,72)
	endif
C
 	if (iflag.eq.1) then
	write(*,273) AYR,AMN,ADY,AUT,(ibesp(k),k=19,72)
	write(15,273) AYR,AMN,ADY,AUT,(ibesp(k),k=19,72)
	write(*,273) AYR,AMN,ADY,AUT,(ibesn(k),k=19,72)
	write(16,273) AYR,AMN,ADY,AUT,(ibesn(k),k=19,72)
	write(*,273) AYR,AMN,ADY,AUT,(ibdst(k),k=19,72)
	write(17,273) AYR,AMN,ADY,AUT,(ibdst(k),k=19,72)
	endif
  870	continue			 ! next event
270   format(72(1X,I4))  
crem 271   format(1X,3A2,1X,A2,4(1X,F7.3),4(1X,F6.0))
272   format(1X,3A2,1X,A2,2(1X,I4),1X,F6.0)
   71	format(A64)
   82	format(2A2,I2,24(1X,I4))
	jrest=jend-jbend
c	write(12,*) ' wpos'
c      do kk=1,jrest
c	write(*,273) (iresp(kk,k),k=19,72)
c	write(12,273) (iresp(kk,k),k=19,72)
c	enddo
c	write(12,*) ' wneg'
c      do kk=1,jrest
c	write(*,273) (iresn(kk,k), k=19,72)
c	write(12,273) (iresn(kk,k),k=19,72)
c	enddo
c	write(112,*) ' Dst'
c      do kk=1,jrest
c	write(*,273) (idst(kk,k),k=19,72)
c	write(12,273) (idst(kk,k),k=19,72)
c	enddo
  273   format(1X,4(A2),54(1X,I4))
		CLOSE(unit=12)
C
c	write(13,*) ' wpos'
c      do kk=1,jbend
c	write(*,273) (ibesp(kk,k),k=19,72)
c	write(13,273) (ibesp(kk,k),k=19,72)
c	enddo
c	write(13,*) ' wneg'
c      do kk=1,jbend
c	write(*,273) (ibesn(kk,k), k=19,72)
c	write(13,273) (ibesn(kk,k),k=19,72)
c	enddo
c	write(13,*) ' Dst'
c      do kk=1,jbend
c	write(*,273) (ibdst(kk,k),k=19,72)
c	write(13,273) (ibdst(kk,k),k=19,72)
c	enddo

	CLOSE(unit=13)
	CLOSE(unit=14)
	CLOSE(unit=15)
	CLOSE(unit=16)
	CLOSE(unit=17)
	goto 900                ! Next input file
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 continue
      pause ' '
      STOP
      END


C ====================================================================
